/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.kbss.ejaservlets;

import cz.cvut.kbss.ejaservlets.support.CaesarCipher;
import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Jednoduchy priklad na servlety - servlet desifrujici text sifrovany Caesarovou sifrou
 * 
 * Vsimnete si, ze zde nemapujeme servlet pomoci anotaci, ale pomoci deskriptoru web.xml
 * v adresari WEB-INF (pripomenme si, ze co je v tomto adresari, to se NIKDY server
 * nezpristupni zvenci). Servlet je zde pojmenovan jako "CaesarCipherDecryptionServlet"
 * a je mapovan na cestu relativni ke kontextu "CaesarCipherDecryptionServlet".
 * 
 * ----------------
 * V realnem svete by byly CSS styly v externim stylopisu, byl by zde doctype a 
 * sifrovaci a desifrovaci servlety by dedily ze spolecneho predka, protoze si jsou
 * dosti podobne
 * 
 * @author Pavel Micka
 */
public class CaesarCipherDecryptionServlet extends HttpServlet {

    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        try {
            String toDecrypt = request.getParameter("cipherText");
            String value = request.getSession().getAttribute("cipherText") == null ? "" : (String) request.getSession().getAttribute("cipherText");

            out.println("<html>");
            out.println("  <head>");
            out.println("    <title>Dešifrování caesarovy šifry</title>");
            out.println("  </head>");
            out.println("  <body>");
            out.println("    <h1>Dešifrování caesarovy šifry</h1>");
            out.println("    <form method='post' action='CaesarCipherDecryptionServlet'>");
            out.println("      <label for='text'>Zadejte prosím šifrovaný text (A-Z)</label>");
            out.println("      <input type='text' id='text' name='cipherText' value='" + value + "'>");
            out.println("      <input type='submit'>");
            out.println("    </form>");
            try {
                if (toDecrypt != null) {
                    String result = CaesarCipher.decipher(toDecrypt);
                    out.println("    <div>Otevřený text: " + result + "</div>");
                }
            } catch (IllegalArgumentException ex) {
                out.println("    <div style='color: red;'>Neplatný formát vstupu: " + toDecrypt + "</div>");
            }
            out.print("    <div style='margin-top: 2em; padding-top: 1em; border-top: 1px dashed black;'><a href='CaesarCipherServlet'>Přejít k šifrování</a></div>");
            out.println("  </body>");
            out.println("</html>");
        } finally {
            out.close();
        }
    }

    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Caesar cipher decryption servlet";
    }
}
