package cz.cvut.kbss.ejaservlets.support;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Test;
import static org.junit.Assert.*;
import org.junit.Before;
import org.junit.BeforeClass;

/**
 *
 * @author ledvima1
 */
public class CaesarCipherTest {

    private static final String PLAIN = "HELLO";
    private static final String ENCRYPTED = "KHOOR";
    
    @BeforeClass
    public static void setUpBeforeClass() {
        System.out.println("@BeforeClass");
    }
    
    @Before
    public void setUp() {
        System.out.println("@Before");
    }
    
    @After
    public void tearDown() {
        System.out.println("@After");
    }
    
    @AfterClass
    public static void tearDownAfterClass() {
        System.out.println("@AfterClass");
    }
    
    public CaesarCipherTest() {
        System.out.println("Constructor");
    }

    @Test
    public void testEncipherSimple() {
        final String result = CaesarCipher.encipher(PLAIN);
        assertEquals(ENCRYPTED, result);
    }

    @Test
    public void testDecipherSimple() {
        final String result = CaesarCipher.decipher(ENCRYPTED);
        assertEquals(PLAIN, result);
    }
    
    @Test(expected = IllegalArgumentException.class)
    public void testSetShiftInvalid() {
        CaesarCipher.setShift(0);
    }

    // Otestujte chovani Caesarovy sifry v hranicnich podminkach
    
    // SOLUTION
    @Test
    public void testEncipherBoundary() {
        final String plain = "WXYZ";
        final String encrypted = "ZABC";

        final String result = CaesarCipher.encipher(plain);
        assertEquals(encrypted, result);
    }

    @Test
    public void testDecipherBoundary() {
        final String plain = "XYZA";
        final String encrypted = "ABCD";

        final String result = CaesarCipher.decipher(encrypted);
        assertEquals(plain, result);
    }
}
